=== debian/changelog ===
spirv-tools (2025.4-1) unstable; urgency=medium

  [ Timo Aaltonen ]
  * New upstream release. (Closes: #1114395)
  * control: Bump build-dep on spirv-headers.

  [ Dylan Aïssi ]
  * Make spirv-tools multi-arch compatible (Closes: #1023780)
    Move some files from spirv-tools to spirv-tools-dev and spirv-tools-headers.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 28 Oct 2025 13:35:38 +0200
